extends Piece

class_name Assassin

enum Upgrade {
	# Add any specific upgrades for Assassin here
}

var board_state: Array

func _my_init(is_white_param: bool, position_param: Vector2):
	super._my_init(is_white_param, position_param)


func _ready():
	capture_gold_value = 5

# Capturing is handled in main game.gd
func get_valid_moves(board: Array, pos: Vector2) -> Array[Vector2]:
	var valid_moves: Array[Vector2] = []
	var sel_x = pos.x
	var sel_y = pos.y

	# Add moves based on the provided logic
	for x in range(board.size()):
		for y in range(board.size()):
			if int((x + y)) % 2 == int((sel_x + sel_y)) % 2 and is_empty(board, x, y):
				valid_moves.append(Vector2(x, y))

	if is_opponent(board, sel_x, sel_y):
		if sel_y - 1 >= 0:
			if is_opposite(board, sel_x, sel_y - 1):
				valid_moves.append(Vector2(sel_x, sel_y - 1))
			if sel_x + 1 < board.size():
				if is_opposite(board, sel_x + 1, sel_y - 1):
					valid_moves.append(Vector2(sel_x + 1, sel_y - 1))
			if sel_x - 1 >= 0:
				if is_opposite(board, sel_x - 1, sel_y - 1):
					valid_moves.append(Vector2(sel_x - 1, sel_y - 1))
	else:
		if sel_y + 1 < board.size():
			if is_opposite(board, sel_x, sel_y + 1):
				valid_moves.append(Vector2(sel_x, sel_y + 1))
			if sel_x + 1 < board.size():
				if is_opposite(board, sel_x + 1, sel_y + 1):
					valid_moves.append(Vector2(sel_x + 1, sel_y + 1))
			if sel_x - 1 >= 0:
				if is_opposite(board, sel_x - 1, sel_y + 1):
					valid_moves.append(Vector2(sel_x - 1, sel_y + 1))

	return valid_moves



func is_empty(board: Array, x: int, y: int) -> bool:
	return board[x][y] == null

func is_opponent(board: Array, x: int, y: int) -> bool:
	return board[x][y] != null and board[x][y].is_white != is_white

func is_opposite(board: Array, x: int, y: int) -> bool:
	return board[x][y] != null and board[x][y].is_white == is_white
