extends Piece

class_name Queen

enum Upgrade {
	# Add any specific upgrades for Queen here
}


func _ready():
	capture_gold_value = 9

func _my_init(is_white_param: bool, position_param: Vector2):
	super._my_init(is_white_param, position_param)

func get_valid_moves(board_state: Array, pos: Vector2) -> Array[Vector2]:
	var valid_moves: Array[Vector2] = []
	var x = pos.x
	var y = pos.y

	# Check moves in the right direction
	for i in range(x + 1, 8):
		if board_state[i][y] == null:
			valid_moves.append(Vector2(i, y))
		elif not board_state[i][y].is_white:
			valid_moves.append(Vector2(i, y))
			break
		else:
			break

	# Check moves in the left direction
	for i in range(x - 1, -1, -1):
		if board_state[i][y] == null:
			valid_moves.append(Vector2(i, y))
		elif not board_state[i][y].is_white:
			valid_moves.append(Vector2(i, y))
			break
		else:
			break

	# Check moves upwards
	for i in range(y - 1, -1, -1):
		if board_state[x][i] == null:
			valid_moves.append(Vector2(x, i))
		elif not board_state[x][i].is_white:
			valid_moves.append(Vector2(x, i))
			break
		else:
			break

	# Check moves downwards
	for i in range(y + 1, 8):
		if board_state[x][i] == null:
			valid_moves.append(Vector2(x, i))
		elif not board_state[x][i].is_white:
			valid_moves.append(Vector2(x, i))
			break
		else:
			break

	# Check moves in the top-right diagonal
	for i in range(1, 8):
		if x + i < 8 and y - i >= 0:
			if board_state[x + i][y - i] == null:
				valid_moves.append(Vector2(x + i, y - i))
			elif not board_state[x + i][y - i].is_white:
				valid_moves.append(Vector2(x + i, y - i))
				break
			else:
				break
		else:
			break

	# Check moves in the top-left diagonal
	for i in range(1, 8):
		if x - i >= 0 and y - i >= 0:
			if board_state[x - i][y - i] == null:
				valid_moves.append(Vector2(x - i, y - i))
			elif not board_state[x - i][y - i].is_white:
				valid_moves.append(Vector2(x - i, y - i))
				break
			else:
				break
		else:
			break

	# Check moves in the bottom-right diagonal
	for i in range(1, 8):
		if x + i < 8 and y + i < 8:
			if board_state[x + i][y + i] == null:
				valid_moves.append(Vector2(x + i, y + i))
			elif not board_state[x + i][y + i].is_white:
				valid_moves.append(Vector2(x + i, y + i))
				break
			else:
				break
		else:
			break

	# Check moves in the bottom-left diagonal
	for i in range(1, 8):
		if x - i >= 0 and y + i < 8:
			if board_state[x - i][y + i] == null:
				valid_moves.append(Vector2(x - i, y + i))
			elif not board_state[x - i][y + i].is_white:
				valid_moves.append(Vector2(x - i, y + i))
				break
			else:
				break
		else:
			break

	return valid_moves
